{ This is the input data:  MinX MinY MaxX MaxY;  N;  x1 y2;  ...;  xN yN;
 30 -50 230 80
  20
 100 -20   60 0      60 20    160 30    70 -40   190 50   120 70
 90 50     50 60     40 -20   150 60    180 10   225 20   230 70
 200 -20   160 -10   150 30   170 -40   130 40   80 30


                       
                     ----------------------------

           N      .
     ,     ,  
           (  ).
                 
            +   +    +    +       +   + ++
           +      +              +      +        
               +                     +          
             +     + +             +    ++
                 
         10    
   .     .

      :      (MinX,MinY)  (MaxX,
 MaxY).    (MinX,MinY)  (MaxX,MaxY)  . 
  P[1], P[2], ..., P[N]     X  . -
     ,       -
   X x1=P[i]  x2=P[j]  i>j.        Y--
      p   p.x > x1  p.x < x2.   -
      0  .     MinY  MaxY.
     Y-      P[i]  P[j].
     Y[1]<Y[2]<...Y[K].      -
  x1  x2   X  (x1,y[1],x2,y[2]), ... (x1,y[K-1],x2,y[K]).  
      - (   
  )      -.      -
 ,      ,    ,
     N*N*N,   -,      ,
   .

                                                                
                                                                   , 1999
}

{$R-,S-,Q-}
CONST InFileName = 'MAXDUPKA.PAS';
      MaxN = 200;

TYPE TPoint = record x,y: integer; end;

VAR MinX,MinY,MaxX,MaxY: integer;
    P: array[1..MaxN] of TPoint;
    N: integer;

    BestS: longint;
    BestX1,BestY1,BestX2,BestY2: integer;


Procedure ReadData; { Read the input data - N, P[1..N], MinX,MinY,MaxX,MaxY }
Var F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,MinX,MinY,MaxX,MaxY);
  ReadLn(F,N);
  for N:= 1 to N do
    with P[N] do
      Read(F,x,y);
  Close(F);
End;


Procedure SortPoints; { Sort P[1..N] in incerasing order by X coordinate }
Var i,j,min: integer;
    Swp: TPoint;
Begin
  Inc(N); with P[N] do begin x:=MinX; y:=MinY; end; {add MinX point}
  Inc(N); with P[N] do begin x:=MaxX; y:=MaxY; end; {add MaxX point}
  for i:= 1 to N-1 do
    begin
      Min:=i;
      for j:= i+1 to N do
        if (P[J].x < P[Min].x) then Min:=j;
      Swp:=P[Min]; P[Min]:=P[i]; P[i]:=Swp;
    end;
End;

Procedure FindMinimalSurfaceRectangle; { Check all possible rectangles }
Var Y: array[1..MaxN] of integer;
    b,e: integer;
    S: longint;

  Procedure Check(x1,y1,x2,y2:integer);
  Begin
    S:= longint(abs(x1-x2)) * abs(y1-y2);
    if S > BestS then
      begin BestS:=S; BestX1:=x1; BestY1:=y1; BestX2:=x2; BestY2:=y2; end;
  End;


  Procedure CheckAllRectanglesBE; { Check all the recrangles between b and e }
  Var Swp,Mid: integer;

    Procedure QSort(Left,Right:word); { Sort Y[Left..Right] }
    Var I,J: integer;
    Begin
      I:=Left; J:=Right; Mid:= Y[(Left+Right) div 2];
      repeat
        while Y[I] < Mid do Inc(I);
        while Mid < Y[J] do Dec(J);
        if I <= J then
          begin Swp:=Y[I]; Y[I]:=Y[J]; Y[J]:=Swp; Inc(I); Dec(J); end;
      until I > J;
      if Left < J then QSort(Left,J);
      if I < Right then QSort(I,Right);
    End;

  Var i,Len: integer;
  Begin
    {The middle points between b and e are bb+1, ..., ee-1}
    Len:=1; Y[Len]:=MinY;
    for i:= b+1 to e-1 do
      begin Inc(Len); Y[Len]:=P[i].y; end;
    Inc(Len); Y[Len]:=MaxY;
    {sort Y[1..Len] in increasing order}
    QSort(1,Len);
    {check all rectangles between b and e - (b,y0,e,y1), (b,y1,e,y2), ... }
    for i:= 1 to Len-1 do
      Check(P[b].x,Y[i],P[e].x,Y[i+1]);
  End;

Begin
  BestS:=-1;
  for b:= 1 to N do
    for e:= b+1 to N do
      CheckAllRectanglesBE;
End;


BEGIN
  ReadData;
  SortPoints;
  FindMinimalSurfaceRectangle;
  WriteLn('The maximal empty rectangle surface = ',BestS);
END.
