{
 4
  2 -8  4 -6
  7  1 -5  3
 -9  7  6  5
  8  3  2 -4

                            
                           ------------------

         N x N (N<=200),    
  .      K x K   (K<=N), -
       .     1   -
   - N   N    N  - .    
 -  .

   :          
  1, 2, ... N        . 
        (BegX,BegY)  
     K = 1, 2, ..., N-Max(BegX,BegY)+1.   
  ,      -  Hor[x,y] 
       (x,y), (x+1,y), ..., (N,y),  ..
      (x,y)     ;   
 Ver[x,y]        (x,y), (x,y+1), ...,
 (x,N), ..      (x,y)    
 .    ,        
  y    x1    x2  Hor[x1,y]-Hor[x2+1,y].  -
             
  .     Sum     
  (BegX,BegY)   K,        -
  K+1   :
    Sum:= Sum + Hor[BegX,BegY+K]-Hor[BegX+K,BegY+K]
              + Ver[BegX+K,BegY]-Ver[BegX+K,BegY+K+1]
   N*N          -
   K = 1, 2, ..., N    ,     -
      N*N*N.

                                                               Star Gruhtar
                                                                  , 1999
}

{$R-,S-,Q-}
CONST InFileName  = 'SQR.PAS';
      OutFileName = '';
      MaxN = 200;

TYPE Table = array[1..MaxN+1] of longint;

VAR N,K: integer;
    T, {     N x N}
    Hor, {Hor[x,y]   T[x,y] + T[x+1,y] + ... + T[N,y]}
    Ver: {Ver[x,y]   T[x,y] + T[x,y+1] + ... + T[x,N]}
      array[1..MaxN+1] of ^Table;
    Best: longint; {     }


Procedure ReadData;
Var F: Text;
    x,y: integer;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  Read(F,N);
  for x:= 1 to N do New(T[x]);
  for y:= 1 to N do
    begin
      ReadLn(F);
      for x:= 1 to N do
        Read(F,T[x]^[y]);
    end;
  Close(F);
End;


Procedure CalculateHorVer; { Calculate Hor[1..N,1..N], Ver[1..N,1..N] }
Var x,y: integer;
Begin
  for x:= 1 to N+1 do
    begin New(Hor[x]); New(Ver[x]); end;
  for y:= 1 to N do
    begin
      Hor[N+1]^[y]:=0;
      for x:= N downto 1 do
        Hor[x]^[y]:= Hor[x+1]^[y] + T[x]^[y];
    end;
  for x:= 1 to N do
    begin
      Ver[x]^[N+1]:=0;
      for y:= N downto 1 do
        Ver[x]^[y]:= Ver[x]^[y+1] + T[x]^[y];
    end;
End;


Procedure Check1K(BegX,BegY: integer);
{  Check the sum of all squares that begin at position
   (BegX,BegY) and have size K = 1, 2, ... N  }
  Function Max(a,b:integer): integer;
  Begin if a > b then Max:=a else Max:=b End;
Var Sum: longint;
    K,x,y: integer;
Begin
  Sum:=0;
  for K:= 0 to N - Max(BegX,BegY) do
    begin
      Sum:= Sum + Hor[BegX]^[BegY+K] - Hor[BegX+K]^[BegY+K]
                + Ver[BegX+K]^[BegY] - Ver[BegX+K]^[BegY+K+1];
      if Sum > Best then
        Best:=Sum;
    end;
End;


Procedure PrintResult;
Var OutF: Text;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  WriteLn(OutF,Best);
  Close(OutF);
End;


VAR BegX,BegY: integer;

BEGIN
  ReadData;
  Best:=-MaxInt;
  CalculateHorVer;
  for BegX:= 1 to N do {Check all begin positions (BegX,BegY)}
    for BegY:= 1 to N do
      Check1K(BegX,BegY);
  PrintResult;
END.